<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\Dao;

use Eccube\Entity\ProductClass;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class ProductClassDao
 * @package Plugin\Logiless\Dao
 */
class ProductClassDao extends AbstractDao
{
    /**
     * 商品情報を取得
     *
     * @param Request $request
     *
     * @return ProductClass[]
     */
    public function getProductClasses(Request $request)
    {
        $qb = $this->createQueryBuilder()
            ->select('pc')
            ->from('Eccube\Entity\ProductClass', 'pc')
            ->innerJoin('pc.Product', 'p')
            ->orderBy('pc.id', 'DESC');

        $criteria = static::buildCriteria($request, array(
            'code' => null,
        ));

        if (!is_null($criteria['code'])) {
            $codeList = is_array($criteria['code']) ? $criteria['code'] : array($criteria['code']);

            $qb
                ->andWhere('pc.code IN (:code_list)')
                ->setParameter('code_list', $codeList);
        }

        $this->paging($qb, $request);

        return $qb->getQuery()->execute();
    }
}