<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\ClassCategory;
use LogicException;

/**
 * Class ClassCategoryE2V
 * @package Plugin\Logiless\E2V
 */
class ClassCategoryE2V extends AbstractE2V
{
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $classCategory) {
            if (!$classCategory instanceof ClassCategory) {
                throw new LogicException();
            }

            $view[] = array(
                'class_name' => $classCategory->getClassName()->getName(),
                'name' => $classCategory->getName(),
            );
        }

        return $view;
    }
}