<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\Customer;
use LogicException;

/**
 * Class CustomerClassE2V
 * @package Plugin\Logiless\E2V
 */
class CustomerE2V extends AbstractE2V
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $customer) {
            if (!$customer instanceof Customer) {
                throw new LogicException();
            }

            $view[] = array(
                'id' => $customer->getId(),
                'status' => $customer->getStatus() ?
                    $customer->getStatus()->getName() : null,
                'sex' => $customer->getSex(),
                'job' => $customer->getJob(),
                'name01' => $customer->getName01(),
                'name02' => $customer->getName02(),
                'kana01' => $customer->getKana01(),
                'kana02' => $customer->getKana02(),
                'company_name' => $customer->getCompanyName(),
                'postal_code' => $customer->getPostalCode(),
                'pref' => $customer->getPref() ?
                    $customer->getPref()->getName() : null,
                'addr01' => $customer->getAddr01(),
                'addr02' => $customer->getAddr02(),
                'email' => $customer->getEmail(),
                'phone_number' => $customer->getPhoneNumber(),
                'first_buy_date' => $customer->getFirstBuyDate() ?
                    $customer->getFirstBuyDate()->format('Y-m-d H:i:s') : null,
                'last_buy_date' => $customer->getLastBuyDate() ?
                    $customer->getLastBuyDate()->format('Y-m-d H:i:s') : null,
                'buy_times' => $customer->getBuyTimes(),
                'buy_total' => $customer->getBuyTotal(),
                'note' => $customer->getNote(),
                'create_date' => $customer->getCreateDate() ?
                    $customer->getCreateDate()->format('Y-m-d H:i:s') : null,
                'update_date' => $customer->getUpdateDate() ?
                    $customer->getUpdateDate()->format('Y-m-d H:i:s') : null,
            );
        }

        return $view;
    }
}