<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\OrderItem;
use LogicException;

/**
 * Class OrderItemE2V
 * @package Plugin\Logiless\E2V
 */
class OrderItemE2V extends AbstractE2V
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $orderItem) {
            if (!$orderItem instanceof OrderItem) {
                throw new LogicException();
            }

            $view[] = array(
                'id' => $orderItem->getId(),
                'product_name' => $orderItem->getProductName(),
                'product_code' => $orderItem->getProductCode(),
                'class_name1' => $orderItem->getClassName1(),
                'class_name2' => $orderItem->getClassName2(),
                'class_category_name1' => $orderItem->getClassCategoryName1(),
                'class_category_name2' => $orderItem->getClassCategoryName2(),
                'price' => $orderItem->getPrice(),
                'price_inc_tax' => $orderItem->getPriceIncTax(),
                'quantity' => $orderItem->getQuantity(),
                'product_class' => $orderItem->getProductClass() ?
                    ProductClassE2V::convert($orderItem->getProductClass()) : null
            );
        }

        return $view;
    }
}